function RR_Test()
	ChatFrame1:AddMessage("Kilerpet's Raid Roll Addon - Loaded")
end

function RaidRoll_OnLoad()

 SLASH_RR1 = "/rr";
 SLASH_RR2 = "/raidroll";
 
 SlashCmdList["RR"] =  RR_Command;
 
 RR_Test()
 
 local f = CreateFrame("Frame")
 
  f:RegisterEvent("CHAT_MSG_SYSTEM")
  
  f:RegisterEvent("CHAT_MSG_PARTY")
  f:RegisterEvent("CHAT_MSG_RAID")
  f:RegisterEvent("CHAT_MSG_RAID_LEADER")
  f:RegisterEvent("CHAT_MSG_RAID_WARNING")
  f:RegisterEvent("CHAT_MSG_SAY")
  f:RegisterEvent("CHAT_MSG_YELL")
  f:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded

  
  
  f:SetScript("OnEvent", RaidRoll_Event)
  
  RR_Has_Rolled = false
  RR_Rolling_on_item = true
  
  rr_rollID = 0
  rr_CurrentRollID = 0
  
-- Define the various arrays
  rr_Roll = {}
  rr_PlayersRolled = {}
  rr_Item = {}
  rr_playername = {}
  RollerRoll = {}
  RollerName = {}
  RollerGroup = {}
  MaxPlayers = {}
  RollerFirst = {}
  RollerRank = {}
  RollerRankIndex = {}
  HasRolled = {}
  Roll_Number = {}

  


  rr_Item[0] = "ID #0"
  
  RollerName[0] = {}
  
  RollerName[0][1] = ""
  
  RR_Timestamp = 0
  
  RR_Doing_a_New_Roll = false
  
  

  


end

-- Setuo extra frame commands
function RR_ExtraFrame_Options()


	Raid_Roll_Name=CreateFrame("FRAME","Raid_Roll_Name",RR_RollFrame);
	Raid_Roll_Name:SetWidth(150); 
	Raid_Roll_Name:SetHeight(20);
	Raid_Roll_Name:SetPoint("TOPLEFT",RR_RollFrame,10, -5);
	
	Raid_Roll_Name_String = Raid_Roll_Name:CreateFontString("Raid_Roll_Name_String" ,"ARTWORK","GameFontNormal");
	Raid_Roll_Name_String:SetAllPoints();
	Raid_Roll_Name_String:SetJustifyH("LEFT")
	
	Raid_Roll_Name_String:SetText("Killerpet's Raid Roller")


--------------------------------------------------------------

	RR_BottomFrame = CreateFrame("Frame","RR_Frame",RR_RollFrame)

	local backdrop = {
	  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
	  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",  -- path to the border texture
	  
	  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
	  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
	  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
	  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
	    left = 4,
	    right = 4,
	    top = 4,
	    bottom = 4
	  }
	}


	RR_BottomFrame:SetBackdrop(backdrop)

	RR_BottomFrame:SetFrameStrata("DIALOG")
	RR_BottomFrame:SetWidth(180) -- Set these to whatever height/width is needed 
	RR_BottomFrame:SetHeight(95) -- for your Texture
	RR_BottomFrame:SetPoint("Top",RR_RollFrame,"Bottom",0,6);

	RR_BottomFrame:EnableMouse(true)
	RR_BottomFrame:SetScript("OnMouseDown",function()
	  getglobal("RR_RollFrame"):StartMoving()
	end)
	RR_BottomFrame:SetScript("OnMouseUp",function()
	  getglobal("RR_RollFrame"):StopMovingOrSizing()
	end)


--------------------------------------------------------------
-- Hide the options frame
--------------------------------------------------------------
	RR_BottomFrame:Hide()
	getglobal("RaidRoll_Catch_All"):Hide()
	getglobal("RaidRoll_Allow_All"):Hide()
--------------------------------------------------------------


--------------------------------------------------------------
-- Set the backdrops for the other frames
--------------------------------------------------------------
	RR_NAME_FRAME:SetBackdrop(backdrop)
	getglobal("RR_RollFrame"):SetBackdrop(backdrop)
--------------------------------------------------------------


RR_RollFrame:Show()


-- Change the height of the main screen
	RR_RollFrame:SetHeight(135)
	RR_RollFrame:SetWidth(230)

-- Change the position of the rolled and group values
	getglobal("RR_Rolled"):ClearAllPoints()
	getglobal("RR_Rolled"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",170,-30)
		
	getglobal("RR_Group"):ClearAllPoints()
	getglobal("RR_Group"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",200,-30)


-- Create 5 strings and a header for the guild ranks
	Raid_Roll_Rank=CreateFrame("FRAME","Raid_Roll_Rank",RR_RollFrame);
	Raid_Roll_Rank:SetWidth(70); 
	Raid_Roll_Rank:SetHeight(15);
	Raid_Roll_Rank:SetPoint("TOPLEFT",RR_RollFrame,105, -30);
	
	Raid_Roll_Rank_String = Raid_Roll_Rank:CreateFontString("Raid_Roll_Rank_String"..0 ,"ARTWORK","GameFontNormal");
	Raid_Roll_Rank_String:SetAllPoints();
	Raid_Roll_Rank_String:SetJustifyH("left")
	
	Raid_Roll_Rank_String:SetText("Rank")
	
	for i=1,5 do
		Raid_Roll_Rank_String_i = Raid_Roll_Rank:CreateFontString("Raid_Roll_Rank_String"..i ,"ARTWORK","GameFontNormal");
		Raid_Roll_Rank_String_i:SetPoint("TOPLEFT",getglobal("Raid_Roll_Rank_String"..i-1),0, -12);
		Raid_Roll_Rank_String_i:SetJustifyH("LEFT")
		Raid_Roll_Rank_String_i:SetWidth(65); 
		Raid_Roll_Rank_String_i:SetHeight(11); 
		
		
		Raid_Roll_Rank_String_i:SetText("Rank "..i)
		
	end



	getglobal("RR_Close_Button"):ClearAllPoints()
	getglobal("RR_Close_Button"):SetWidth(30)
	getglobal("RR_Close_Button"):SetHeight(30)
	getglobal("RR_Close_Button"):SetPoint("TopRight", getglobal("RR_RollFrame"), "TopRight",0,0)

	getglobal("RR_Last"):ClearAllPoints()
	getglobal("RR_Last"):SetPoint("Bottom", getglobal("RR_RollFrame"), "Bottom",-60,10)
	getglobal("RR_Last"):SetText("<<<")
		
	getglobal("RR_Clear"):ClearAllPoints()
	getglobal("RR_Clear"):SetPoint("Bottom", getglobal("RR_RollFrame"), "Bottom",-10,10)

	getglobal("RR_Next"):ClearAllPoints()
	getglobal("RR_Next"):SetPoint("Bottom", getglobal("RR_RollFrame"), "Bottom",40,10)
	getglobal("RR_Next"):SetText(">>>")
	
	getglobal("RaidRoll_Catch_All"):ClearAllPoints()
	getglobal("RaidRoll_Catch_All"):SetPoint("BottomLeft", RR_BottomFrame, "BottomLeft",10,70)

	getglobal("RaidRoll_Allow_All"):ClearAllPoints()
	getglobal("RaidRoll_Allow_All"):SetPoint("BottomLeft", RR_BottomFrame, "BottomLeft",10,55)

	RR_Roll_Options = CreateFrame("Button", "RaidRoll_OptionButton", RR_RollFrame, "UIPanelButtonTemplate")
	RR_Roll_Options:SetWidth(18)
	RR_Roll_Options:SetHeight(18)
	RR_Roll_Options:SetPoint("Bottom", RR_RollFrame, "Bottom", 74, 11)
	RR_Roll_Options:SetText("v")
	RR_Roll_Options:SetScript("OnClick",RR_Roll_Options_Toggle)

	RR_RollCheckBox_ExtraRolls = CreateFrame("CheckButton", "RaidRollCheckBox_ExtraRolls", RR_BottomFrame, "UICheckButtonTemplate")
	RR_RollCheckBox_ExtraRolls:SetWidth(20)
	RR_RollCheckBox_ExtraRolls:SetHeight(20)
	RR_RollCheckBox_ExtraRolls:SetPoint("BottomLeft", RR_BottomFrame, "BottomLeft", 10, 40)
	getglobal("RaidRollCheckBox_ExtraRolls".."Text"):SetText("Allow Extra Rolls")
	RR_RollCheckBox_ExtraRolls:SetScript("OnClick",RaidRoll_CheckButton_Update)

	RR_RollCheckBox_ShowRanks = CreateFrame("CheckButton", "RaidRollCheckBox_ShowRanks", RR_BottomFrame, "UICheckButtonTemplate")
	RR_RollCheckBox_ShowRanks:SetWidth(20)
	RR_RollCheckBox_ShowRanks:SetHeight(20)
	RR_RollCheckBox_ShowRanks:SetPoint("BottomLeft", RR_BottomFrame, "BottomLeft", 10, 25)
	getglobal("RaidRollCheckBox_ShowRanks".."Text"):SetText("Show Rank Beside Name")
	RR_RollCheckBox_ShowRanks:SetScript("OnClick",RaidRoll_CheckButton_Update)

	RR_RollCheckBox_RankPrio = CreateFrame("CheckButton", "RaidRollCheckBox_RankPrio", RR_BottomFrame, "UICheckButtonTemplate")
	RR_RollCheckBox_RankPrio:SetWidth(20)
	RR_RollCheckBox_RankPrio:SetHeight(20)
	RR_RollCheckBox_RankPrio:SetPoint("BottomLeft", RR_BottomFrame, "BottomLeft", 10, 10)
	getglobal("RaidRollCheckBox_RankPrio".."Text"):SetText("Give Higher Ranks Priority")
	RR_RollCheckBox_RankPrio:SetScript("OnClick",RaidRoll_CheckButton_Update)


	
-- RESET the position of the frame to the center of the screen
	--getglobal("RR_RollFrame"):ClearAllPoints(); getglobal("RR_RollFrame"):SetPoint("CENTER", UIParent, "CENTER", 0, 0)

end

-- TOGGLE THE OPTIONS MENU
function RR_Roll_Options_Toggle()

	if RR_BottomFrame:IsShown() then
		getglobal("RaidRoll_Catch_All"):Hide()
		getglobal("RaidRoll_Allow_All"):Hide()
		RR_BottomFrame:Hide()
	else
		getglobal("RaidRoll_Catch_All"):Show()
		getglobal("RaidRoll_Allow_All"):Show()
		RR_BottomFrame:Show()
	end


end



-- sets up the name frame
function RR_SetupNameFrame()

RR_NAME_FRAME = CreateFrame("Frame",nil,UIParent)

local backdrop = {
  --bgFile="Interface\DialogFrame\UI-DialogBox-Background",  -- path to the background texture
  --edgeFile="Interface\DialogFrame\UI-DialogBox-Border",  -- path to the border texture
  
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  -- path to the background texture
  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",  -- path to the border texture

  
  tile = true,    -- true to repeat the background texture to fill the frame, false to scale it
  tileSize = 32,  -- size (width or height) of the square repeating background tiles (in pixels)
  edgeSize = 20,  -- thickness of edge segments and square size of edge corners (in pixels)
  insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
    left = 2,
    right = 2,
    top = 2,
    bottom = 2
  }
}

RR_NAME_FRAME:SetBackdrop(backdrop)




RR_NAME_FRAME:SetFrameStrata("DIALOG")
--RR_NAME_FRAME:SetWidth(128) -- Set these to whatever height/width is needed 
--RR_NAME_FRAME:SetWidth(128) -- Set these to whatever height/width is needed 
RR_NAME_FRAME:SetHeight(30) -- for your Texture

RR_NAME_FRAME:SetWidth(getglobal("RR_Itemname"):GetWidth() + 20)
	

RR_NAME_FRAME:SetPoint("BOTTOM", "RR_RollFrame", "TOP", 0, -8);

RR_NAME_FRAME:Hide()

RR_NAME_FRAME:SetMovable(true)
RR_NAME_FRAME:EnableMouse(true)
RR_NAME_FRAME:SetScript("OnMouseDown",function()
  RR_RollFrame:StartMoving()
end)
RR_NAME_FRAME:SetScript("OnMouseUp",function()
  RR_RollFrame:StopMovingOrSizing()
end)




RR_Itemname:SetPoint("TOPLEFT",RR_NAME_FRAME,"TOPLEFT",11,-8)

end


----------------------------------------------------------------------------------------------

function RaidRoll_Event()

if event == "ADDON_LOADED" and arg1 == "RaidRoll" then

	RR_SetupNameFrame()
	RR_ExtraFrame_Options()

-- Catch unannounced rolls
	if RR_Track_Unannounced_Rolls == nil or RR_Track_Unannounced_Rolls == false then
		RR_Track_Unannounced_Rolls = false	--Set true if unannounced rolls are tracked
		RaidRoll_Catch_All:SetChecked(false)
	else
		RaidRoll_Catch_All:SetChecked(true)
	end
	
-- Allow all rolls (e.g. 1-50)
	if RR_Accept_All_Rolls == nil or RR_Accept_All_Rolls == false then
		RR_Accept_All_Rolls = false	--Set true if all rolls are counted (False = only 1-100 rolls are counted)
		RaidRoll_Allow_All:SetChecked(false)
	else
		RaidRoll_Allow_All:SetChecked(true)
	end

-- Allow Extra Rolls
	if RR_AllowExtraRolls == nil or RR_AllowExtraRolls == false then
		RR_AllowExtraRolls = false	--
		RR_RollCheckBox_ExtraRolls:SetChecked(false)
	else
		RR_RollCheckBox_ExtraRolls:SetChecked(true)
	end
	
-- Show Rank beside names
	if RR_Show_Ranks == nil or RR_Show_Ranks == false then
		RR_Show_Ranks = false	--
		RR_RollCheckBox_ShowRanks:SetChecked(false)
	else
		RR_RollCheckBox_ShowRanks:SetChecked(true)
	end
	
-- Give higher ranks higher priority
	if RR_RankPriority == nil or RR_RankPriority == false then
		RR_RankPriority = false	--
		RR_RollCheckBox_RankPrio:SetChecked(false)
	else
		RR_RollCheckBox_RankPrio:SetChecked(true)
	end


	RR_Next:Disable()
	RR_Last:Disable()
	
-- This controls the showing of the window (true = show window, false = dont show window)
	if RR_Roll_Tracking_Enabled == nil then
		RR_Roll_Tracking_Enabled = true
	end
	
	if RR_Roll_Tracking_Enabled == false then
		ChatFrame1:AddMessage("Raid Roll: Raid Roll Tracking disabled. Type ''/rr enable'' to enable tracking")
	end
	
-- sets up the name frame
	--RR_SetupNameFrame()
	
	RaidRoll_CheckButton_Update()
end




--ChatFrame1:AddMessage(arg1)

--ChatFrame1:AddMessage("An event has occured")

if event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID_WARNING" or event == "CHAT_MSG_SAY" or event == "CHAT_MSG_YELL" then
	--ChatFrame1:AddMessage(arg1)	--Debugging, shows what messages are said
	
	arg1_s = string.lower(arg1)
	
--Find the start and end location of the item link
	xRR_Start_Loc,_ = string.find(arg1_s, "item:");
	_,xRR_End_Loc = string.find(arg1_s, "|h|r")
	
	if xRR_Start_Loc == nil then xRR_Start_Loc = 0 end
	if xRR_End_Loc == nil then xRR_End_Loc = 0 end
	
	
--Get the words before and after the item link
	RR_String_minus_ILink1 = strsub(arg1,0,xRR_Start_Loc-12)
	RR_String_minus_ILink2 = strsub(arg1,xRR_End_Loc,strlen(arg1))
	
--If they are nil set them to blank values
	if RR_String_minus_ILink1 == nil then RR_String_minus_ILink1 = "" end
	if RR_String_minus_ILink2 == nil then RR_String_minus_ILink2 = "" end

--Put them together
	RR_String_minus_ILink = RR_String_minus_ILink1 .. RR_String_minus_ILink2
	
--Debugging, Shows the item string without the item link
	--ChatFrame1:AddMessage(RR_String_minus_ILink)	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	if string.find(arg1_s, "|h|r") ~= nil and string.find(RR_String_minus_ILink, "roll") ~= nil and string.find(RR_String_minus_ILink, "raid roll") == nil then 
		--ChatFrame1:AddMessage("Rolling on an item detected")
		
	--Timestamp of when the rolling was announced
		RR_Timestamp = time()
		--ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp)	--Debugging, displays the timestamp
		
		-- This being false tells us that we should begin decrementing the counter
		RR_Doing_a_New_Roll = false
		
		
	--Cut the itemlink out of the string
		if xRR_Start_Loc ~= nil and xRR_End_Loc ~= nil then
			xRR_ItemLink = strsub(arg1,xRR_Start_Loc-12,xRR_End_Loc)
		end
	--For debugging, show the itemlink
		--ChatFrame1:AddMessage(xRR_ItemLink)
		
		if rr_Item[rr_rollID] ~= "ID #"..rr_rollID or RollerName[rr_rollID][1] ~= "" then
		
			rr_rollID = rr_rollID + 1	
			
			
			if rr_CurrentRollID+1 == rr_rollID then
				rr_CurrentRollID = rr_rollID
			end
		end
		
			rr_Item[rr_rollID] = xRR_ItemLink
			rr_RollSort(rr_rollID,0,"",true)

		

		
		--ChatFrame1:AddMessage("New item roll found, ID#" .. rr_rollID)
	end
	
	RR_Rolling_on_item = true
	
end





if RR_Rolling_on_item == true and event == "CHAT_MSG_SYSTEM" and string.find(arg1, "rolls")then 
	--ChatFrame1:AddMessage("Roll Detected")	--Debugging, fires when a roll is detected
	
	--ChatFrame1:AddMessage("Roll detected " .. time() - RR_Timestamp .. " seconds after announcement") 
	
	if time() < RR_Timestamp + 60 or RR_Track_Unannounced_Rolls == true then
		
	--This creates a new window for rolls made more than 60 seconds after the last roll if the option to track unannounced rolls is turned on
		if RR_Track_Unannounced_Rolls == true then
			if time() > RR_Timestamp + 60 then
				RR_NewRoll()
			end
		end
		
		-- This controls the showing of the window (true = show window, false = dont show window)
		if RR_Roll_Tracking_Enabled == true then
			RR_RollFrame:Show()
			RR_NAME_FRAME:Show()
		end
		
		if string.find(arg1, "%(1%-100%)") ~= nil or RR_Accept_All_Rolls == true then
			--ChatFrame1:AddMessage("Legitimate Roll")	--Debugging, tells you if the roll is a real roll or fake
			
			-- This being false tells us that we should begin decrementing the counter
			RR_Doing_a_New_Roll = false
			
			--Wait for the player to roll
			rr_endname,roll_loc = string.find(arg1, " rolls");
			
			roll_loc_end = string.find(arg1, " %(");
			
			
				--Find where in the roll the number is
			if roll_loc ~= nil then
				rr_player_roll = strsub(arg1,roll_loc+2,roll_loc_end-1)
				
				--if strsub(arg1,roll_loc+4,roll_loc+4) == "0" then 
				--	rr_player_roll = "100"
				--	ChatFrame1:AddMessage("Player rolled 100!")		--Debugging, only happens when 100 is rolled
				--end
				
				rr_player_name = strsub(arg1,1,rr_endname-1)
				
				--ChatFrame1:AddMessage(rr_player_name .. " Rolled " .. rr_player_roll)	--Debugging, shows what the player rolled
				
				if rr_Roll[rr_rollID] == nil then rr_Roll[rr_rollID] = {} end
				
				if rr_Roll[rr_rollID][rr_player_name] == nil then
					rr_Roll[rr_rollID][rr_player_name] = tonumber(rr_player_roll)
					if rr_PlayersRolled[rr_rollID] == nil then 
						rr_PlayersRolled[rr_rollID] = 1
					else
						rr_PlayersRolled[rr_rollID] = rr_PlayersRolled[rr_rollID] + 1
					end
					--ChatFrame1:AddMessage("Total players rolled: " .. rr_PlayersRolled[rr_rollID])	-- Debugging message, tells you how many ppl have rolled unique rolls
					
					if rr_playername[rr_rollID] == nil then	rr_playername[rr_rollID] = {} end
					
					rr_playername[rr_rollID][rr_PlayersRolled[rr_rollID]] = rr_player_name	
					
					rr_RollSort(rr_rollID,rr_player_roll,rr_player_name,true,true)
					
				else
					rr_RollSort(rr_rollID,rr_player_roll,rr_player_name,true,false)
					--ChatFrame1:AddMessage(rr_player_name .. " already rolled. Ignoring roll")	--Debugging message, tells you if ppl roll twice
				end
				
			end
			
		else
			--ChatFrame1:AddMessage("Fake Roll, Ignore")	--Debugging, shows when an unacceptable roll is done
		end
	end

end


if RR_Has_Rolled == true and event == "CHAT_MSG_SYSTEM" then
	
	--Wait for the player to roll
	null,roll_loc = string.find(arg1, UnitName("player") .. " rolls");

	--Find where in the roll the number is
	if roll_loc ~= nil then
		my_roll = strsub(arg1,roll_loc+2,roll_loc+3)
	end
	
	--Convert it from a string to a number
	my_roll = tonumber(my_roll)

	if GetRaidRosterInfo(my_roll) ~= nil and roll_loc ~= nil and RR_ItemLink == nil then
		SendChatMessage(">>> " .. RR_Name_Array[my_roll] .. " Wins! <<<", rr_AnnounceType1)
	end
	
	if GetRaidRosterInfo(my_roll) ~= nil and roll_loc ~= nil and RR_ItemLink ~= nil then
		SendChatMessage(">>> " .. RR_Name_Array[my_roll] .. " Wins " .. RR_ItemLink .. "! <<<", rr_AnnounceType1)
	end
	
	RR_Has_Rolled  = false
end


end


-- PlayerRoll = the roll performed 
-- PlayerName = the name of the player who rolled
-- rr_rollID = the id of the list
-- rr_FirstRoll = was it this persons first roll? (true / false)
-- rr_AddedPlayer = if we added a player this is true, otherwise it is false (for re-sorting)


function rr_RollSort(rr_rollID,PlayerRoll,PlayerName,rr_AddedPlayer,rr_FirstRoll)


--ChatFrame1:AddMessage(MaxPlayers[rr_rollID])
		

local temp

--if rr_rollID == nil then rr_rollID = rr_CurrentRollID end 

	if rr_AddedPlayer == true then
		
	-- Checks for the variables that are passed to make sure no nil values are passed
		if rr_FirstRoll ==   nil then 	rr_FirstRoll = false   end	-- Was this their first roll?
		if rr_GuildRank ==   nil then 	rr_GuildRank = ""      end	-- What was their Guild Rank?
		if rr_AddedPlayer == nil then 	rr_AddedPlayer = true  end	-- Are you adding more players to the list or just re-sorting? (SET THIS TO DEFAULT FALSE)
		

		
	-- If this is the first time that it is called then set the max rollers value to zero
		if MaxPlayers[rr_rollID] == nil then MaxPlayers[rr_rollID] = 0 end
		
	-- If you are to add a player then increment the value
		if rr_AddedPlayer == true then MaxPlayers[rr_rollID] = MaxPlayers[rr_rollID] + 1 end
		
		
		
	-- If there are less than 5 rollers then set the value to 5 (to avoid bugs)
		if MaxPlayers[rr_rollID] < 5 then
			MaxPlayersValue = 5
		else
			MaxPlayersValue = MaxPlayers[rr_rollID]
		end
		
		
		
		
	-- Making the variable to an array
		if RollerName[rr_rollID] == nil then RollerName[rr_rollID] = {} end
		if RollerRoll[rr_rollID] == nil then RollerRoll[rr_rollID] = {} end
		if RollerFirst[rr_rollID] == nil then RollerFirst[rr_rollID] = {} end
		if RollerRank[rr_rollID] == nil then RollerRank[rr_rollID] = {} end
		if RollerRankIndex[rr_rollID] == nil then RollerRankIndex[rr_rollID] = {} end
		if HasRolled[rr_rollID] == nil then HasRolled[rr_rollID] = {} end		
		if Roll_Number[rr_rollID] == nil then Roll_Number[rr_rollID] = {} end		
		
		
		
		if HasRolled[rr_rollID][PlayerName] == nil then
			HasRolled[rr_rollID][PlayerName] = 1
		else
			HasRolled[rr_rollID][PlayerName] = HasRolled[rr_rollID][PlayerName] + 1
		end
		
		Roll_Number[rr_rollID][MaxPlayersValue] = HasRolled[rr_rollID][PlayerName]
		
	-- Filling in the blank values with dummies
		for i=1,MaxPlayersValue-1 do
			if RollerName[rr_rollID][i]  == nil then RollerName[rr_rollID][i]  = "" end
			if RollerRoll[rr_rollID][i]  == nil then RollerRoll[rr_rollID][i]  = 0  end
			if RollerFirst[rr_rollID][i] == nil then RollerFirst[rr_rollID][i] = false end
			if RollerRank[rr_rollID][i]  == nil then RollerRank[rr_rollID][i]  = "" end
			if RollerRankIndex[rr_rollID][i]  == nil then RollerRankIndex[rr_rollID][i]  = 99 end
		end
		
	-- Setting the players name, roll, guild rank and roll status to the current max players value
		if rr_AddedPlayer == true then
			RollerName[rr_rollID][MaxPlayersValue] = PlayerName
			RollerRoll[rr_rollID][MaxPlayersValue] = tonumber(PlayerRoll)
			
			RollerFirst[rr_rollID][MaxPlayersValue] = rr_FirstRoll
			
		-- Default rank and rank id values (will be overwritten if the person is in the guild
			RollerRank[rr_rollID][MaxPlayersValue] = ""
			RollerRankIndex[rr_rollID][MaxPlayersValue] = 99
			
		-- Get how many guild members are online
			numOnline = GetNumGuildMembers()
			
		-- scan the guild info for the person 
			for i=1,numOnline do
				name, rank, rankIndex = GetGuildRosterInfo(i)
			
			-- If a match is found set the rank and rankindex 
				if PlayerName == name then
					RollerRank[rr_rollID][MaxPlayersValue] = rank
					RollerRankIndex[rr_rollID][MaxPlayersValue] = rankIndex
				end
			end		
			
		-- Debugging, lists the name, guild rank, and guild rank id of the player (Rank ID starts at 0)
			--ChatFrame1:AddMessage(RollerName[rr_rollID][MaxPlayersValue] .. " " .. RollerRank[rr_rollID][MaxPlayersValue] .. " " .. RollerRankIndex[rr_rollID][MaxPlayersValue])
			
		end	
		
	--Debugging values 
		--[[
		RollerRoll[rr_rollID][1] = 2
		RollerRoll[rr_rollID][2] = 4
		RollerRoll[rr_rollID][3] = 5
		RollerRoll[rr_rollID][4] = 1
		RollerRoll[rr_rollID][5] = 9
		]]
		
	end
		
	
	if MaxPlayersValue ~= nil then
		
		for i=1,MaxPlayersValue do
			--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
			for j=1,MaxPlayersValue-1 do
				--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
				if RollerRoll[rr_rollID][j+1] ~= nil then
					if RollerRoll[rr_rollID][j+1] > RollerRoll[rr_rollID][j] then
						RaidRoll_Flip(rr_rollID,j)
					end
				end
			end
		end
		
		if RR_RankPriority == true then
			for i=1,MaxPlayersValue do
				--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
				for j=1,MaxPlayersValue-1 do
					--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
					--ChatFrame1:AddMessage("i=" .. i .. " j=" .. " " .. j .. RollerRankIndex[rr_rollID][j+1] .. "/" .. RollerRankIndex[rr_rollID][j])
					if RollerRankIndex[rr_rollID][j+1] ~= nil then
						if RollerRankIndex[rr_rollID][j+1] < RollerRankIndex[rr_rollID][j] then
							RaidRoll_Flip(rr_rollID,j)
						end
					end
				end
			end
		end
		
		
		if RR_AllowExtraRolls == false then
			for i=1,MaxPlayersValue do
				--ChatFrame1:AddMessage(i)	-- Debugging, shows the ''i'' value
				for j=1,MaxPlayersValue-1 do
					--ChatFrame1:AddMessage(j) 	-- Debugging, shows the ''j'' value
					--ChatFrame1:AddMessage("i=" .. i .. " j=" .. j .. " " .. RollerRankIndex[rr_rollID][j+1] .. "/" .. RollerRankIndex[rr_rollID][j])
					if RollerFirst[rr_rollID][j+1] ~= nil then
						if RollerFirst[rr_rollID][j+1] == true and RollerFirst[rr_rollID][j] == false then
							RaidRoll_Flip(rr_rollID,j)
						end
					end
				end
			end
		end
		
		
		
--Debugging, lists all the raid rolls
		--[[ChatFrame1:AddMessage("Listing Results")
		for i=1,41 do
			ChatFrame1:AddMessage(RollerName[rr_rollID][i])
			ChatFrame1:AddMessage(RollerRoll[rr_rollID][i])
		end
		]]
		
		if rr_CurrentRollID == rr_rollID then
				RR_Display(rr_rollID)
		end
		
	end
	
end

function RaidRoll_Flip(rr_rollID,j)

	temp = RollerRoll[rr_rollID][j+1]
	RollerRoll[rr_rollID][j+1] = RollerRoll[rr_rollID][j]
	RollerRoll[rr_rollID][j] = temp
	
	temp = RollerName[rr_rollID][j+1]
	RollerName[rr_rollID][j+1] = RollerName[rr_rollID][j]
	RollerName[rr_rollID][j] = temp
	
	temp = RollerRank[rr_rollID][j+1]
	RollerRank[rr_rollID][j+1] = RollerRank[rr_rollID][j]
	RollerRank[rr_rollID][j] = temp
	
	temp = RollerRankIndex[rr_rollID][j+1]
	RollerRankIndex[rr_rollID][j+1] = RollerRankIndex[rr_rollID][j]
	RollerRankIndex[rr_rollID][j] = temp
	
	temp = RollerFirst[rr_rollID][j+1]
	RollerFirst[rr_rollID][j+1] = RollerFirst[rr_rollID][j]
	RollerFirst[rr_rollID][j] = temp
	
	temp = Roll_Number[rr_rollID][j+1]
	Roll_Number[rr_rollID][j+1] = Roll_Number[rr_rollID][j]
	Roll_Number[rr_rollID][j] = temp
end


function RR_Update_Name_Frame(RR_DisplayID)

l_RR_DisplayID = RR_DisplayID

	-- If you clicked "new roll" then dont  decrement the timer (unless there was a roll performed)
	if RR_Doing_a_New_Roll == true then RR_Timestamp = time() end

	if time() < RR_Timestamp + 60 and rr_rollID == rr_CurrentRollID then
		getglobal("RR_Itemname"):SetText("(" .. 60 - time() + RR_Timestamp .. ") " .. rr_Item[l_RR_DisplayID])
	else
		getglobal("RR_Itemname"):SetText(rr_Item[l_RR_DisplayID])
	end
	
	
	--RR_width = getglobal("RR_Itemname"):GetWidth();

	RR_NAME_FRAME:SetWidth(getglobal("RR_Itemname"):GetWidth() + 20)
	
	--if RR_width + 45 > 185 then
	--	RR_RollFrame:SetWidth(RR_width+45);
	--else
	--	RR_RollFrame:SetWidth(185);
	--end
	

	
	if not _RR then 
		UIParent:HookScript("OnUpdate",function() if _RR>0 and GetTime()>=_RR then _RR=0 RR_Update_Name_Frame(l_RR_DisplayID); end end)
	end 
	_RR=GetTime()
	

	
end

function RR_Display(RR_DisplayID)

RR_HasDisplayedAlready = true

l_RR_DisplayID = RR_DisplayID

	if RollerGroup[l_RR_DisplayID] == nil then RollerGroup[l_RR_DisplayID] = {} end

---If the current roll is the latest rol it shows a 60 second countdown
	if time() < RR_Timestamp + 60 and rr_rollID == rr_CurrentRollID then
		getglobal("RR_Itemname"):SetText("(" .. 60 - time() + RR_Timestamp .. ") " .. rr_Item[l_RR_DisplayID])
		RR_Update_Name_Frame(l_RR_DisplayID)
	else
		getglobal("RR_Itemname"):SetText(rr_Item[l_RR_DisplayID])
	end
	
	if RollerFirst[RR_DisplayID] ~= nil and RollerFirst[RR_DisplayID][1] ~= nil then
		for i=1,5 do
			if RollerFirst[RR_DisplayID][i] == false then
				color = "|cFF11aacc"
			else
				color = "|cFFFF0000|r"
			end
			
			if (RollerFirst[RR_DisplayID][i] == true and RR_AllowExtraRolls == false) or RR_AllowExtraRolls == true then
				getglobal("RR_Roller"..i):SetText(color .. RollerName[RR_DisplayID][i])
				
				if RollerRoll[RR_DisplayID][i] == 0 then
					getglobal("RR_Rolled"..i):SetText("")
				else
					if RollerFirst[RR_DisplayID][i] == true then
						getglobal("RR_Rolled"..i):SetText(color .. RollerRoll[RR_DisplayID][i])
					else
						getglobal("RR_Rolled"..i):SetText(color .. "(" .. Roll_Number[RR_DisplayID][i] .. ") " .. RollerRoll[RR_DisplayID][i])
					end
				end
				
				if RollerRankIndex[RR_DisplayID][i] == 99 then
					getglobal("Raid_Roll_Rank_String"..i):SetText("")
				else
					getglobal("Raid_Roll_Rank_String"..i):SetText(color .. "(" .. RollerRankIndex[RR_DisplayID][i] .. ") " .. RollerRank[RR_DisplayID][i])
				end
				
				for j = 1,40 do
					local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(j);
					
					--ChatFrame1:AddMessage(j .. name .. subgroup)
					
					if name == RollerName[RR_DisplayID][i] then
						--ChatFrame1:AddMessage(i .. " " .. RollerName[RR_DisplayID][i] .. " - " .. name)
						RollerGroup[RR_DisplayID][i] = subgroup
					end
				end
				
				if RollerGroup[RR_DisplayID][i] == nil then RollerGroup[RR_DisplayID][i] = "" end
				getglobal("RR_Group"..i):SetText(color .. RollerGroup[RR_DisplayID][i])
			else
				getglobal("RR_Roller"..i):SetText("")
				getglobal("RR_Rolled"..i):SetText("")
				getglobal("Raid_Roll_Rank_String"..i):SetText("")
				getglobal("RR_Group"..i):SetText("")
			end
		end
	end

	-- This controls the showing of the window (true = show window, false = dont show window)
		if RR_Roll_Tracking_Enabled == true then
			RR_RollFrame:Show()
			RR_NAME_FRAME:Show()
		end
	
	if rr_rollID ~= 0 then
		if rr_CurrentRollID < rr_rollID then
			RR_Next:Enable()
		else
			RR_Next:Disable()
		end
		
		if rr_CurrentRollID > 0 then
			RR_Last:Enable()
		else
			RR_Last:Disable()
		end
	else
		RR_Last:Disable()
		RR_Next:Disable()
	end
	
end


function RR_Command(cmd)
--Stuff that happens when you press /mm <command>

RR_ItemLink = nil --clearing the variable

cmd_n = tonumber(cmd)

--Do a standard Raid roll
	if cmd_n ~= nil or cmd == "" then 
		if GetNumRaidMembers() ~= 0 then
			if cmd == "" then
				RR_DoARaidRoll(GetNumRaidMembers())
			end
			
			if type(cmd_n) == "number" then
				if cmd_n > GetNumRaidMembers() then
					cmd_n = GetNumRaidMembers();
				end
				
				--ChatFrame1:AddMessage(cmd_n)
				RR_DoARaidRoll(cmd_n)
			end
			
			--ChatFrame1:AddMessage(type(cmd_n))
		else
			ChatFrame1:AddMessage("You are not in a raid group")
		end
	end

	
cmd_s = string.lower(cmd)

-- reset the position of the rolling frame
	if cmd_s == "reset" or cmd_s == "resetpos" then
		getglobal("RR_RollFrame"):ClearAllPoints(); 
		getglobal("RR_RollFrame"):SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	end


	if cmd_s == "show" then
		RR_RollFrame:Show()
		RR_NAME_FRAME:Show()
	end
	
	if cmd_s == "test" then
		 RR_Test()
	end	
	
	--[[if cmd_s == "re" or cmd_s == "reroll" then
		if RR_num ~= nil then
			RR_Roll()
		else
			RR_DoARaidRoll(GetNumRaidMembers())
		end
	end	]]--
	
--Find the start and end location of the item link
	RR_Start_Loc,_ = string.find(cmd, "item:");
	_,RR_End_Loc = string.find(cmd, "|h|r")
	
--Cut the itemlink out of the string
	if RR_Start_Loc ~= nil and RR_End_Loc ~= nil then
		RR_ItemLink = strsub(cmd,RR_Start_Loc-12,RR_End_Loc)
	end
--For debugging, show the itemlink
	--ChatFrame1:AddMessage(RR_ItemLink)

--Cut up the command to see if it was a reroll or not
	RR_Reroll = strsub(cmd_s,1,3)
	RR_Reroll_Long = strsub(cmd_s,1,6)
	
--for debugging, show the results of the split up string
	--ChatFrame1:AddMessage(RR_Reroll)
	--ChatFrame1:AddMessage(RR_Reroll_Long)
	

	if RR_Reroll == "re " or RR_Reroll_Long == "reroll" then
		if RR_num ~= nil then
			if RR_ItemLink ~= nil then
				SendChatMessage("<<Raid Rolling for: ".. RR_ItemLink .. " >>" , rr_AnnounceType2)
			end
			
			RR_Roll()
		else
			RR_DoARaidRoll(GetNumRaidMembers())
		end
	end
	
	if strsub(cmd,1,1) == "|" then
		RR_DoARaidRoll(GetNumRaidMembers())
	end
	
	if cmd_s == "all" then
		if RR_Accept_All_Rolls == true then
			RR_Accept_All_Rolls =  false
			ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
			RaidRoll_Allow_All:SetChecked(false);
		else
			RR_Accept_All_Rolls =  true
			ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
			RaidRoll_Allow_All:SetChecked(true);
		end
		
	end
	
	
	if cmd_s == "unan" or cmd_s == "unannounced" then
		if RR_Track_Unannounced_Rolls == true then
			RR_Track_Unannounced_Rolls =  false
			ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Disabled")
			RaidRoll_Catch_All:SetChecked(false);
		else
			RR_Track_Unannounced_Rolls =  true
			ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Enabled")
			RaidRoll_Catch_All:SetChecked(true);
		end
	end	

-- This controls the showing of the window (true = show window, false = dont show window)
	if cmd_s == "enable" then
		RR_Roll_Tracking_Enabled = true
		ChatFrame1:AddMessage("Raid Roll: Raid Roll Tracking enabled. Type ''/rr disable'' to disable tracking")
	end	
	
	if cmd_s == "disable" then
		RR_Roll_Tracking_Enabled = false
		ChatFrame1:AddMessage("Raid Roll: Raid Roll Tracking disabled. Type ''/rr enable'' to enable tracking")
	end	
	
end

function RR_DoARaidRoll(num)

	RR_num = num
	
	RR_Name_Array = {}
	
	if UnitInRaid("player") then 
		rr_AnnounceType1 = "RAID"
		if IsRaidLeader() ~= nil or IsRaidOfficer() ~= nil then
			rr_AnnounceType2 = "RAID_WARNING"
		else
			rr_AnnounceType2 = "RAID"
		end
	else
		rr_AnnounceType1 = "PARTY"
		rr_AnnounceType2 = "RAID_WARNING"
	end		
	
	if RR_ItemLink == nil then
		SendChatMessage("<<Raid Rolling>> (ID - Name)" , rr_AnnounceType1)
	end
	
	if RR_ItemLink ~= nil then
		SendChatMessage("<<Raid Rolling for: " .. RR_ItemLink .. " >> (ID - Name)" , rr_AnnounceType2)
	end
	
	for i=1,num do
		RR_Name_Array[i] = GetRaidRosterInfo(i)
		--SendChatMessage(RR_Name_Array[i], "PARTY")	--Debugging, shows all the members of the raid in party chat
	end
	
		
	if num < 21 then 
		num = num + 1
		for i=1,num/2 do
			i_mod = 2 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-1 then 
				SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "" .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), rr_AnnounceType1)
			else
				SendChatMessage("#".. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), rr_AnnounceType1)
			end
			--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
			--ChatFrame1:AddMessage(num)				
		end
	else
		num = num + 2
		for i=1,num/3 do
			i_mod = 3 * i
			--ChatFrame1:AddMessage(i_mod .. num)
			if GetRaidRosterInfo(i_mod) ~= nil and i_mod <= num-2 then 
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1) .. "    #" .. i_mod .." - " .. GetRaidRosterInfo(i_mod), rr_AnnounceType1)
			elseif GetRaidRosterInfo(i_mod-1) ~= nil and  i_mod <= num-1 then
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2) .. "" .. "    #" .. i_mod-1 .." - " .. GetRaidRosterInfo(i_mod-1), rr_AnnounceType1)
			else
				SendChatMessage("#".. i_mod-2 .." - " .. GetRaidRosterInfo(i_mod-2), rr_AnnounceType1)
			end
			--ChatFrame1:AddMessage("#".. i .." - " .. GetRaidRosterInfo(i))
			--ChatFrame1:AddMessage(num)				
		end
	end
	
	if not _Y then 
		UIParent:HookScript("OnUpdate",function() if _Y>0 and GetTime()>=_Y then _Y=0 RR_Roll(); end end)
	end 
	_Y=GetTime()+2
	
end

function RR_Roll()

RandomRoll(1,RR_num);

RR_Has_Rolled = true

end


function RR_CloseWindow()
	RR_RollFrame:Hide()
	RR_NAME_FRAME:Hide()
end

function RR_PrevRoll()
	if rr_CurrentRollID > 0 then
		rr_CurrentRollID = rr_CurrentRollID - 1
		RR_Display(rr_CurrentRollID)
	end
	
	if rr_CurrentRollID == 0 then 
		RR_Last:Disable()
		RR_Next:Enable()
	else
		RR_Last:Enable()
		RR_Next:Enable()
	end
	
	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

function RR_NewRoll()
	
	RR_Timestamp = time()
	--ChatFrame1:AddMessage("Timestamp set to :" .. RR_Timestamp)	--Debugging, displays the timestamp
	
	RR_Doing_a_New_Roll = true

	if RollerName[rr_rollID][1] ~= "" or rr_Item[rr_rollID] ~= "ID #"..rr_rollID then
		rr_rollID = rr_rollID + 1		
		
		rr_Item[rr_rollID] = "ID #"..rr_rollID
		
		
		if rr_CurrentRollID+1 == rr_rollID then
			rr_CurrentRollID = rr_rollID
			RR_Last:Enable()
		end
		
		rr_RollSort(rr_rollID,0,"",true)
	end
	
	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

function RR_NextRoll()
	if rr_CurrentRollID < rr_rollID then
		rr_CurrentRollID = rr_CurrentRollID + 1
		RR_Display(rr_CurrentRollID)
	end
	
	if rr_CurrentRollID == rr_rollID then 
		RR_Next:Disable()
		RR_Last:Enable()
	else
		RR_Next:Enable()
		RR_Last:Enable()
	end	
	
	rr_RollSort(rr_CurrentRollID)
	RR_Display(rr_CurrentRollID)
end

function RaidRoll_CheckButton_Update()

--RaidRoll_Allow_All:SetChecked(true);
	if RaidRoll_Catch_All:GetChecked() then
		RR_Track_Unannounced_Rolls =  true
		--ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Enabled")
	else
		RR_Track_Unannounced_Rolls =  false
		--ChatFrame1:AddMessage("Raid Roll: Auto-Tracking Rolls Disabled")
	end

	if RaidRoll_Allow_All:GetChecked() then
		RR_Accept_All_Rolls =  true
		--ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
	else
		RR_Accept_All_Rolls =  false
		--ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
	end
	
	if RR_RollCheckBox_ExtraRolls:GetChecked() then
		RR_AllowExtraRolls =  true
		--ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
	else
		RR_AllowExtraRolls =  false
		--ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
	end

	if RR_RollCheckBox_ShowRanks:GetChecked() then
		RR_Show_Ranks =  true
		for i=1,6 do
			getglobal("Raid_Roll_Rank_String"..i-1):Show()
		end
		RR_RollFrame:SetWidth(250)
		getglobal("RR_Rolled"):ClearAllPoints()
		getglobal("RR_Rolled"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",170,-30)
		
		getglobal("RR_Group"):ClearAllPoints()
		getglobal("RR_Group"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",220,-30)
	else
		RR_Show_Ranks =  false
		for i=1,6 do
			getglobal("Raid_Roll_Rank_String"..i-1):Hide()
		end
		RR_RollFrame:SetWidth(200)
		getglobal("RR_Rolled"):ClearAllPoints()
		getglobal("RR_Rolled"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",120,-30)
		
		getglobal("RR_Group"):ClearAllPoints()
		getglobal("RR_Group"):SetPoint("TOPLEFT", getglobal("RR_RollFrame"), "TOPLEFT",170,-30)
	end

	
	
	if RR_RollCheckBox_RankPrio:GetChecked() then
		RR_RankPriority =  true
		--ChatFrame1:AddMessage("Raid Roll: All rolls accepted")
	else
		RR_RankPriority =  false
		--ChatFrame1:AddMessage("Raid Roll: Only 1-100 rolls accepted")
	end
	
	rr_RollSort(rr_CurrentRollID)
	
	if RR_HasDisplayedAlready ~= nil then
		RR_Display(rr_CurrentRollID)
	end
	
end
